Subject: [PATCH v2] ARM: tlb: ASID macro should give 32bit result for BE correct operation

From: [email-masked] (Ben Dooks)
Date: Mon, 07 Oct 2013 19:24:57 +0200

On 07/10/13 18:37, Victor Kamensky wrote:
> On 7 October 2013 08:57, Ben Dooks<[email-masked]>  wrote:
>> On 07/10/13 17:48, Victor Kamensky wrote:
>>>
>>> Hi Will, Ben, Russell, Thomas,
>>>
>>> Please review second version of patch that fixes TLB asid issue in big
>>> endian
>>> V7 image.
>>>
>>> Changes from v1:
>>>      Note previous patch subject line was 'ARM: tlb:
>>>      __flush_tlb_mm need to use int asid var for BE correct operation'
>>>
>>>      Added 'unsigned int' cast into ASID macro itself rather
>>>      then use intermediate 'int' variable in __flush_tlb_mm function.
>>>      This is done per v1 patch discussion at
>>>
>>>
>>> http://lists.infradead.org/pipermail/linux-arm-kernel/2013-October/202583.html
>>>
>>> Tested with Linaro BE topic branch on Arndale board. Both LE and BE
>>> images were tested.
>>
>>
>> If you are booting on the Arndale board, is there a patch to mark
>> the relevant Exynos devices as BE capable?
>
> Arndale need massive fixes in their BSP layer to be endian agnostic
> ARM V7 platform. Unfortunate it is not as simple as with few others
> that already marked as BE capable.
>
> Please see
> https://git.linaro.org/gitweb?p=people/victor.kamensky/linux-linaro-tracking-be.git;a=shortlog;h=refs/heads/llct-be-topic
> Mostly it is __raw_xxx conversion to xxx_relaxed, but there are
> more subtle changes (some of them similar to changs that you've
> done for other platforms). Also there are known unfixed issues like
> disabling CONFIG_MMC_DW_IDMAC config because idmac
> DMA related code is not endian agnostic yet (btw interesting class
> of BE related problem that was not seen before).

Ok, will have a look. I'm interested as I may be able to
update my techcon paper and possibly insert a slide or two.

> In Linaro we use Arndale and Pandaboard as reference platforms
> therefore we have BE BSP fixes in our tree. But I am not sure
> what is fate of those in long term. Also we consider these as
> example of BSP changes that other BSP need to do.
>
> If Exynos and OMAP owners will have any interest for BE images,
> and would like to see these changes in main line, we gladly
> will work on this. Otherwise changes like this can mess up with
> BSP ongoing drivers development.
>
> I think above position is consistent with similar discussion on
> some of BE related threads - changing BSP to support BE mode
> is BSP owners call.

I'm not sure if it will ever be interesting to OMAP, especially
as it is pretty much a dead-end.

It would be nice to see the Exynos support it.

-- 
Ben Dooks				http://www.codethink.co.uk/
Senior Engineer				Codethink - Providing Genius